<?php


/* To change From Data */
add_action( 'wpcf7_before_send_mail', 'frontapp_wpcf7_do_changes' );

function frontapp_wpcf7_do_changes( $WPCF7_ContactForm ) {

	// Get current form
	$wpcf7 = WPCF7_ContactForm::get_current();

	// get current SUBMISSION instance
	$submission = WPCF7_Submission::get_instance();

	// Ok go forward
	if ( $submission ) {

		// get submission data
		$data = $submission->get_posted_data();

		// nothing's here... do nothing...
		if ( empty( $data ) ) {
			return;
		}

		// extract posted data for example to get name and change it
		$name = isset( $data['your-name'] ) ? $data['your-name'] : '';

		$your_email = isset( $data['your-email'] ) ? $data['your-email'] : '';

		// do some replacements in the cf7 email body
		$mail = $wpcf7->prop( 'mail' );

		// Find/replace the "[your-name]" tag as defined in your CF7 email body
		// and add changes name
		$mail['recipient'] = get_option( 'admin_email' );

		// Save the email body
		$wpcf7->set_properties( array( 'mail' => $mail ) );

		// return current cf7 instance
		return $wpcf7;

	}

}


/* Check mail and send mail data to Front Inbox */
add_filter( 'wp_mail', 'frontapp_wp_mail_filter' );

function frontapp_wp_mail_filter( $args ) {

	$to = $args['to'];

	if ( get_option( 'admin_email' ) == $to ) {

		// Front Api Header
		$args_frontapp = array(
			'headers' => array(
				'Accept'        => 'application/json',
				'Content-Type'  => 'application/json',
				'Authorization' => 'Bearer ' . stripslashes_deep( esc_attr( get_option( 'frontapp_auth' ) ) ),
			),
		);
		// Front Api Request to Validate Access Token
		$request = wp_remote_get( 'https://api.frontapp.com/me', $args_frontapp );

		if ( isset( $request['body'] ) ) {

			$response = json_decode( $request['body'] );

			if ( ! isset( $response->_error ) ) {
				// Front Api Request For inbox
				$inboxes = wp_remote_get( 'https://api2.frontapp.com/inboxes', $args_frontapp );

				$inbox_body = json_decode( $inboxes['body'] );

				foreach ( $inbox_body->_results as  $inboxes_results ) {

					if ( isset( $inboxes_results->name ) && $inboxes_results->name == stripslashes_deep( esc_attr( get_option( 'frontapp_inbox' ) ) ) ) {

						$to = $inboxes_results->send_as;

					}
				}
			}
		}
	}

	$new_wp_mail = array(
		'to'          => $to,
		'subject'     => $args['subject'],
		'message'     => $args['message'],
		'headers'     => $args['headers'],
		'attachments' => $args['attachments'],
	);

	return $new_wp_mail;

}


// For Front Chat to add js
add_action( 'wp_footer', 'frontapp_add_this_script_footer' );

function frontapp_add_this_script_footer() {
	if ( get_option( 'frontapp_freshchat' ) == 'yes' ) {
		?>
		<script src="https://chat-assets.frontapp.com/v1/chat.bundle.js"></script>
		<script>window.FrontChat('init', {chatId: '<?php echo get_option( 'frontapp_chat_id' ); ?>', useDefaultLauncher: true});</script>
		<?php
	}
}
